package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLIdentifierList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLIdentifierList extends JNIObject  {
	
	/* @generated */
	protected ISLIdentifierList(long ptr) {
		/*** PROTECTED REGION ID(ISLIdentifierList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLIdentifierList build(long ptr) {
		return new ISLIdentifierList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLIdentifierList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_id_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLIdentifierList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_id_list_alloc) DISABLED START ***/
		ISLIdentifierList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifierList.build(ISLNative.isl_id_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLIdentifierList idlist, int format) { 
		/*** PROTECTED REGION ID(static_isl_id_list_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_id_list_to_string(getNativePtr(idlist), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_id_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_id_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_id_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_copy 
	 * 
	 * @generated
	**/
	public ISLIdentifierList copy() {
		/*** PROTECTED REGION ID(isl_id_list_copy) DISABLED START ***/
		ISLIdentifierList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifierList.build(ISLNative.isl_id_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_id_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_id_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_n_id 
	 * 
	 * @generated
	**/
	public int getNbIdentifiers() {
		/*** PROTECTED REGION ID(isl_id_list_n_id) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_id_list_n_id(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_get_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier get(int index) {
		/*** PROTECTED REGION ID(isl_id_list_get_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_id_list_get_id(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_set_id 
	 * 
	 * @take this id
	 * @generated
	**/
	public ISLIdentifierList set(int index, ISLIdentifier id) {
		/*** PROTECTED REGION ID(isl_id_list_set_id) DISABLED START ***/
		ISLIdentifierList res;
		
		synchronized(LOCK) {
			checkParameters(this, id);
			try {
				res = ISLIdentifierList.build(ISLNative.isl_id_list_set_id(getNativePtr(this), index, getNativePtr(id)));
			} finally {
				taken(this);
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLIdentifierList insert(int pos, ISLIdentifier el) {
		/*** PROTECTED REGION ID(isl_id_list_insert) DISABLED START ***/
		ISLIdentifierList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLIdentifierList.build(ISLNative.isl_id_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLIdentifierList add(ISLIdentifier el) {
		/*** PROTECTED REGION ID(isl_id_list_add) DISABLED START ***/
		ISLIdentifierList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLIdentifierList.build(ISLNative.isl_id_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLIdentifierList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_id_list_drop) DISABLED START ***/
		ISLIdentifierList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLIdentifierList.build(ISLNative.isl_id_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLIdentifierList concat(ISLIdentifierList list2) {
		/*** PROTECTED REGION ID(isl_id_list_concat) DISABLED START ***/
		ISLIdentifierList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLIdentifierList.build(ISLNative.isl_id_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLIdentifierList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
